<template>
  <div>
    <section class="add mt-1 mt-md-3">
      <div class="controls">
        <button
          class="btn btn-outline-primary text-secondary font-weight-bold p-0"
          @click="diminish()"
        >
          -
        </button>
        <input
          type="number"
          min="0"
          step="1"
          class="text-center px-1"
          disabled
          v-model="quantity"
        />
        <button
          class="btn btn-outline-primary text-secondary font-weight-bold p-0"
          @click="increase()"
        >
          +
        </button>
      </div>
      <div class="button-container">
        <button
          class="btn btn-success text-white p-0 m-0 w-100 h-100"
          :disabled="loading || product.estado === 'Desactivado'"
          @click="addToCart"
        >
          <span v-if="!loading">Agregar</span>

          <span v-else>
            <i class="fas fa-check"></i>
          </span>
        </button>
      </div>
    </section>

    <div v-if="showStockMessage">
      <p class="small text-danger mt-2 mb-0">Stock máximo {{ product.stok_real }} uds</p>
      <p class="small">{{ quantityInCart }} uds. en el carrito actualmente</p>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  name: "AddToCart",
  data() {
    return {
      quantity: 1,
      loading: false,
      showStockMessage: false,
      quantityInCart: 0
    };
  },
  props: {
    product: Object,
  },
  methods: {
    increase() {
      if (this.quantity < this.product.stok_real) {
        this.quantity++;
      }
    },
    diminish() {
      if (this.quantity > 1) {
        this.quantity--;
      }
    },
    addToCart() {
      this.quantityInCart = this.findQuantity();
      this.quantityInCart = this.quantityInCart ? this.quantityInCart.quantity : 0;

      if (this.product.stok_real >= this.quantity + this.quantityInCart) {
        this.loading = true;

        let dataToCart = {
          quantity: this.quantity,
          product: this.product,
        };

        this.$store.commit("cart/ADD_PRODUCT", dataToCart);

        this.showStockMessage = false

        this.$toast.success("Producto agregado", {
          position: "top-right",
          duration: 2000,
        });

        setTimeout(() => {
          this.loading = false;
        }, 1500);
      } else {
        this.showStockMessage = true;
      }
    },
    findQuantity() {
      let cart = this.cart;

      return cart.find((item) => item.id == this.product.id);
    },
  },
  computed: {
    ...mapGetters({
      cart: "cart/getCart",
    }),
  },
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";
@import "~/assets/scss/mixins";

.add {
  height: 25px;
  display: grid;
  grid-template-columns: 48% 48%;
  grid-gap: 4%;

  @media (min-width: 768px) {
    height: 30px;
  }

  .controls {
    @include cart-controls;
  }

  .btn.btn-success {
    font-size: 0.8rem !important;
  }
}
</style>
